package iet.jxufe.cn.android.pageswitcher;
import java.util.ArrayList;
import java.util.List;
import android.app.Activity;
import android.os.Bundle;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.PagerTabStrip;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
public class MainActivity extends Activity {
	private ViewPager mViewPager;//ŶҳĿؼ
	private PagerTabStrip mTab;//ҳѡ
	private LinearLayout mImgs;//ŵײͼƬԲ
	private int[] layouts = new int[] { R.layout.linearlayout,
			R.layout.framelayout, R.layout.gridlayout };//ҳĲļ
	private String[] titles = new String[] { "ָĻ", "޺", ""};
	private ImageView[] mImgViews = new ImageView[layouts.length];//ŵײСԲͼƬؼ
	private List<View> views = new ArrayList<View>();//ҳļ
	private List<String> pagerTitles = new ArrayList<String>();	//бļ
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);			
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);//ĻΪȫʾ
		setContentView(R.layout.activity_main);		
		mImgs = (LinearLayout) findViewById(R.id.mImgs);//IDȡӦĿؼ
		mViewPager = (ViewPager) findViewById(R.id.mViewPager);
		mTab = (PagerTabStrip) findViewById(R.id.mTab);// ѡ֮ı߾࣬ĬһҳпԿѡ		
		mTab.setTextSpacing(300);//ѡ֮ı߾
		init();//ִгʼ
		mViewPager.setAdapter(new MyPagerAdapter());//ΪViewPagerؼ
		initImg();//ʼʾͼƬ		
		mViewPager.setOnPageChangeListener(new MyPageChangeListener());// ΪViewPagerؼҳ仯¼
	}
	// Զҳ任¼
	private class MyPageChangeListener implements OnPageChangeListener {		
		public void onPageScrollStateChanged(int arg0) {
		}
		public void onPageScrolled(int arg0, float arg1, int arg2) {
		}			
		public void onPageSelected(int selected) {// ʾҳ淢仯ʱ				
			resetImg();// õײʾͼƬ			
			mImgViews[selected].setImageResource(R.drawable.choosed);// ǰҳӦͼƬΪɫ
		}
	}
	//ԶPagerAdapter࣬ڷװҪлĶҳ	 
	private class MyPagerAdapter extends PagerAdapter {				
		public int getCount() {// ÷ҳĸ
			return views.size();
		}
		public boolean isViewFromObject(View arg0, Object arg1) {
			return arg0 == arg1;
		}		
		public CharSequence getPageTitle(int position) {// ÷ڷҳı
			return pagerTitles.get(position);
		}
		// ÷ڳʼָҳ
		public Object instantiateItem(ViewGroup container, int position) {
			((ViewPager) container).addView(views.get(position));			
			return views.get(position);
		}
		// ÷ָҳ		
		public void destroyItem(ViewGroup container, int position, Object object) {
			((ViewPager) container).removeView(views.get(position));			
		}
	}	 
	public void init() {//÷ڳʼҪʾҳ棬ӵ	
		for (int i = 0; i < layouts.length; i++) {
			View view = getLayoutInflater().inflate(layouts[i], null);
			views.add(view);
			pagerTitles.add(titles[i]);
		}
	}	
	public void initImg() {//÷ڳʼײͼƬͼƬӵˮƽԲ
		for (int i = 0; i < mImgViews.length; i++) {
			mImgViews[i] = new ImageView(MainActivity.this);
			if (i == 0) {//Ĭµһͼѡ
				mImgViews[i].setImageResource(R.drawable.choosed);
			} else {
				mImgViews[i].setImageResource(R.drawable.unchoosed);
			}
			mImgViews[i].setPadding(20, 0, 0, 0);
			mImgViews[i].setId(i);
			mImgViews[i].setOnClickListener(mOnClickListener);
			mImgs.addView(mImgViews[i]);
		}
	}
	// һĵ¼ڴײͼƬĵ¼
	// ¼ҪлͼƬʾͼƬʾΪɫʾΪɫ
	private OnClickListener mOnClickListener = new OnClickListener() {		
		public void onClick(View v) {			
			resetImg();// ͼƬʾеͼƬΪɫ			
			((ImageView) v).setImageResource(R.drawable.choosed);// ͼƬΪɫ			
			mViewPager.setCurrentItem(v.getId());// лҳʾݵͼƬʾӦҳ
		}
	};	
	public void resetImg() {// ÷ڽеImageViewʾΪδѡ״̬ͼƬ	
		for (int i = 0; i < mImgViews.length; i++) {
			mImgViews[i].setImageResource(R.drawable.unchoosed);
		}
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
}